# Generated by Django 3.2.25 on 2024-04-25 12:25

from django.db import migrations, models


def copy_condition_to_conditions(apps, schema_editor):
    Infrastructure = apps.get_model('infrastructure', 'Infrastructure')

    # Copy InfrastructureCondition ForeignKey to ManyToMany field
    for infrastructure in Infrastructure.objects.all():
        if infrastructure.condition:
            infrastructure.conditions.add(infrastructure.condition)


class Migration(migrations.Migration):

    dependencies = [
        ('infrastructure', '0038_rename_access_tmp_infrastructure_access'),
    ]

    operations = [
        migrations.AddField(
            model_name='infrastructure',
            name='conditions',
            field=models.ManyToManyField(blank=True, related_name='infrastructures', to='infrastructure.InfrastructureCondition', verbose_name='Conditions'),
        ),
        migrations.RunPython(copy_condition_to_conditions, reverse_code=migrations.RunPython.noop),
    ]
